//*****************************
//* Display Drawing Interface
//*****************************
//* Author: Jrgen Birkler
//* (C) 2000
//*****************************

#include "hardware.h"
#include "i2c.h"
#include "display.h"
#include "debug.h"


//#define DISPLAY_BUFFER(x,y,ch) DisplayBuffer[y][x]=ch;

/*
void Display_DrawTextId(Position_t x,Position_t y,Dimension_t width,Alignment_t Alignment, TextId textId)
{
  Dimension_t textWidth = Display_GetTextWidth(textId);
//  I2C_SendStartBit();
//  I2C_SendByte(LCD_DRIVER_ADDRESS);
//  I2C_SendByte(LCD_DATA_COMMAND_CONTINUE);
//  I2C_SendByte(LCD_SET_DDRAM_ADDRESS|LCD_GET_DDRAM_ADDR(x,y));
//  I2C_SendByte(LCD_WRITE_DATA);

  if (Alignment == AlignLeft)
  {
    unsigned char i;
    textWidth = MIN(textWidth,width);
    for (i=0; i < textWidth; i++)
    {
//      I2C_SendByte(TextGetChar(textId,i)^0x80);
      DISPLAY_BUFFER(x+i,y,TextGetChar(textId,i));
    }
    for (; i < width; i++)
    {
//      I2C_SendByte(' '^0x80);
      DISPLAY_BUFFER(x+i,y,' ')
    }
  }
  else if (Alignment == AlignCenter)
  {
    unsigned char i;
    unsigned char space;
    textWidth = MIN(textWidth,width);
    space = (width - textWidth) / 2;
    for (i=0; i < space; i++)
    {
//      I2C_SendByte(' '^0x80);
      DISPLAY_BUFFER(x+i,y,' ');
    }
    for (i=0; i < textWidth; i++)
    {
//      I2C_SendByte(TextGetChar(textId,i)^0x80);
      DISPLAY_BUFFER(x+i+space,y,TextGetChar(textId,i));
    }
    for (i+=space; i < width; i++)
    {
//     I2C_SendByte(' '^0x80);
      DISPLAY_BUFFER(x+i,y,' ');
    }
  }
  else if (Alignment == AlignRight)
  {
    unsigned char i;
    {
      unsigned char space;
      space = (width - MIN(textWidth,width));
      for (i=0; i < space; i++)
      {
//        I2C_SendByte(' '^0x80);
        DISPLAY_BUFFER(x+i,y,' ');
      }
    }
    {
      unsigned char offset = textWidth - MIN(textWidth,width);
      for (; i < width; i++)
      {
//        I2C_SendByte(TextGetChar(textId,i)^0x80);
        DISPLAY_BUFFER(x+i,y,TextGetChar(textId,offset));
        offset++;
      }
    }
  }
//  I2C_SendStopBit();
}
*/


static unsigned char Initialize(void)
{
  I2C_SendStartBit();
  (void)I2C_SendByte(LCD_DRIVER_ADDRESS);
  (void)I2C_SendByte(LCD_CONTROL_BYTE_WRITE_COMMAND);
  (void)I2C_SendByte(LCD_FUNCTION_SET);
  (void)I2C_SendByte(LCD_CONTROL_BYTE_WRITE_COMMAND);
  (void)I2C_SendByte(LCD_DISPLAY_CONTROL);
  (void)I2C_SendByte(LCD_CONTROL_BYTE_WRITE_COMMAND);
  (void)I2C_SendByte(LCD_ENTRY_MODE);
  (void)I2C_SendByte(LCD_CONTROL_BYTE_WRITE_COMMAND);
  if (I2C_SendByte(LCD_CLEAR_DISPLAY))
    DEBUG_PRINT_INFO_("\r\nLCD init");
  
  I2C_SendStopBit();

	return 1;
  //return result;
}


/*
void Display_Update(void)
{
  unsigned char y;
  //DEBUG_STRING_("\r\n-------------",0);
  for (y=0;y < DISPLAY_Y_HEIGHT;y++)
  {
    char* p = DisplayBuffer[y];
    unsigned char x;
    //DisplayBuffer[y][DISPLAY_X_WIDTH]=0;
    //DEBUG_STRING_("\r\n|%s|",p);
    
    I2C_SendStartBit();
    I2C_SendByte(LCD_DRIVER_ADDRESS);
    I2C_SendByte(LCD_DATA_COMMAND_CONTINUE);
    I2C_SendByte(LCD_SET_DDRAM_ADDRESS|LCD_GET_DDRAM_ADDR(0,y));
    I2C_SendByte(LCD_WRITE_DATA);
    
    for (x=0; x <  DISPLAY_X_WIDTH;x++)
    {
      I2C_SendByte((*p)^0x80);
      p++;
    }
    I2C_SendStopBit();
    
  }
  //DEBUG_STRING_("\r\n-------------",0);
}

*/

static void Display_SetDDRAMAddress(unsigned char x, unsigned char y)
{
	I2C_SendStartBit();
	I2C_SendByte(LCD_DRIVER_ADDRESS);
	I2C_SendByte(LCD_CONTROL_BYTE_WRITE_COMMAND);
	I2C_SendByte(LCD_SET_DDRAM_ADDRESS(LCD_GET_DDRAM_ADDR(x,y)));
	I2C_SendStopBit();
}

static unsigned char initialized = 0;


void Display_OutChar(char ch)
{
	static unsigned char ddram_address = 0;
	static unsigned char x_pos = 0;
	static unsigned char y_pos = 0;

	if (!initialized)
	{
		initialized = Initialize();
		ddram_address = 0x20;
		x_pos = 0;
		y_pos = 0;
	}


	switch (ch)
	{
		case '\r':
			//Carrige return
			x_pos = 0;
			Display_SetDDRAMAddress(x_pos,y_pos);
			break;

		case '\n':
			//New line
			y_pos++;
			if (y_pos >= DISPLAY_Y_HEIGHT)
			{
				//TODO:Shift display
			}
			Display_SetDDRAMAddress(x_pos,y_pos);
			break; 


		case '\b':
			//Backspace
			if (x_pos > 0)
				x_pos--;
			break;

		case '\v':
			//Vertical Tab
			x_pos = 0;
			y_pos = 0;
			Display_SetDDRAMAddress(x_pos,y_pos);
			break;

		case '\f':
			//Form feed
			x_pos = 0;
			y_pos = 0;
			I2C_SendStartBit();
			I2C_SendByte(LCD_DRIVER_ADDRESS);
			I2C_SendByte(LCD_CONTROL_BYTE_WRITE_COMMAND);
			I2C_SendByte(LCD_CLEAR_DISPLAY);
		  I2C_SendStopBit();
			break;

		default:
			if (x_pos < DISPLAY_X_WIDTH)
			{
				I2C_SendStartBit();
				I2C_SendByte(LCD_DRIVER_ADDRESS);
				I2C_SendByte(LCD_CONTROL_BYTE_WRITE_DATA);
				I2C_SendByte((ch)^0x80);
				I2C_SendStopBit();
				x_pos++;
			}
			break;
	}

}


void Display_On(void)
{
  LCD_POWER_ON();
}

void Display_Off(void)
{
  LCD_POWER_OFF();
  initialized = false;
}

void Display_Init(void)
{
  LCD_INIT();
}



/*
void Display_Backlight(bool backlightOn)
{
  if (backlightOn) {
    BACKLIGHT_ON();
  }
  else {
    BACKLIGHT_OFF();
  }
}


*/

