/*********************************************************************
 *   _      _        _     _                             _           *
 *  | |__  (_) _ __ | | __| |  ___  _ __    _ __    ___ | |_         *
 *  | '_ \ | || '__|| |/ /| | / _ \| '__|  | '_ \  / _ \| __|        *
 *  | |_) || || |   |   < | ||  __/| |   _ | | | ||  __/| |_         *
 *  |_.__/ |_||_|   |_|\_\|_| \___||_|  (_)|_| |_| \___| \__|        *
 *                                                                   *
 *********************************************************************
 * Copyright 2002                                                    *
 * Jrgen Birkler (birkler@yahoo.com)                                *
 *********************************************************************/

/**
 * @file
 * Buzzer Utilities library
 * @ingroup ATMEL_AVR_Embedded_BuzzerUtilities
 * @author Jrgen Birkler (birkler@yahoo.com) 
 */
                                                                  

/**
 * @defgroup ATMEL_AVR_Embedded_BuzzerUtilities Buzzer Utilities
 * Controls buzzer connected to Timer1, different tones and beep can be produces
 * @ingroup ATMEL_AVR_Embedded
 * 
 */
 
/** 
 * \addtogroup ATMEL_AVR_Embedded_BuzzerUtilities
 * \@{
 */

#ifndef __BUZZER_H__
#define __BUZZER_H__

#include <stdbool.h>


#define Buzzer_Pause 'p'
#define Buzzer_High 'h'
#define Buzzer_Low 'l'
#define Buzzer_Medium 'l'


/**
 * Plays a buzzer play string on the buzzer.
 * If buzzer already playing then it is first stopped.
 * @param playString String to play
 * @see Buzzer_Stop
 *
 */
void Buzzer_Buzz(void);


inline bool Buzzer_PowerSaveOk(void);

#endif //__BUZZER_H__

