
#include "isqrt.h"

/*
//LISTING 4
//An improved version.
unsigned int lisqrt(unsigned long a)
{
  //Hand optimized for AVR GCC 3.2
  unsigned char i=16;
  unsigned long rem = 0;
  unsigned long root = 0;
  do
  {
    unsigned char temp;
    temp = (unsigned char)(a >> 24);
    temp >>=6;
    root <<= 1;
    rem <<=2;
    rem |= temp;
    //rem = ((rem << 2) + (a >> 30));
    a <<= 2;
    root++;
    if(root <= rem){
      rem -= root;
      root++;
    }
    else
    {
      root>>=1;
    }
  } while (i-->0);
  return (unsigned short)(root >> 1);
}

*/
unsigned int lisqrt(unsigned long a)
{
  unsigned long rem = 0;
  unsigned long root = 0;
  unsigned char i;
  for(i=0; i<16; i++)
  {
    unsigned long divisor;
    root <<= 1L;
    rem = ((rem << 2L) + (a >> 30L));
    a <<= 2L;
    divisor = root;
    divisor <<= 1;
    divisor++;
    if(divisor <= rem)
    {
      rem -= divisor;
      root++;
    }
  }
  return (unsigned int)(root);
}


unsigned long int sqr_li(signed int a)
{
  signed long int res = a;
  res *= res;
  return (unsigned long int)res;
}

