#ifndef _PRINTF_P_H_
#define _PRINTF_P_H_

#include <avr/pgmspace.h>
#include <avr/io.h>




///The printf functions, uses callback to output character
int _formatted_write(const char* fmt0,void put_one_char(char, void *),void *secret_pointer, ...);

///for sprintf
void put_c_in_string (char c, void *ptr);

///sprintf function
#define sprintf(s,format, args...)   _formatted_write(PSTR(format),put_c_in_string,&s, ## args)


///External sendchar function, for example UART
extern void sendchar(char c);

void put_c_to_sendchar (char c, void *ptr);

#define printf(format, args...)   _formatted_write(PSTR(format),put_c_to_sendchar,0 , ## args)


//External dbg_sendchar, for example debug monitor or UART.
extern void dbg_sendchar(char data, void* not_used);

#define dbg_printf(format, args...)   _formatted_write(PSTR(format),dbg_sendchar,0, ## args)


#endif
